# coding: utf-8

"""
    torc

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v0.6.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from torc.openapi_client.models.aws_scheduler_model import AwsSchedulerModel
from torc.openapi_client.models.local_scheduler_model import LocalSchedulerModel
from torc.openapi_client.models.slurm_scheduler_model import SlurmSchedulerModel
from typing import Optional, Set
from typing_extensions import Self

class WorkflowSpecificationsSchedulers(BaseModel):
    """
    Data model for all schedulers in the workflow
    """ # noqa: E501
    aws_schedulers: Optional[List[AwsSchedulerModel]] = None
    local_schedulers: Optional[List[LocalSchedulerModel]] = None
    slurm_schedulers: Optional[List[SlurmSchedulerModel]] = None
    __properties: ClassVar[List[str]] = ["aws_schedulers", "local_schedulers", "slurm_schedulers"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkflowSpecificationsSchedulers from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in aws_schedulers (list)
        _items = []
        if self.aws_schedulers:
            for _item_aws_schedulers in self.aws_schedulers:
                if _item_aws_schedulers:
                    _items.append(_item_aws_schedulers.to_dict())
            _dict['aws_schedulers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in local_schedulers (list)
        _items = []
        if self.local_schedulers:
            for _item_local_schedulers in self.local_schedulers:
                if _item_local_schedulers:
                    _items.append(_item_local_schedulers.to_dict())
            _dict['local_schedulers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in slurm_schedulers (list)
        _items = []
        if self.slurm_schedulers:
            for _item_slurm_schedulers in self.slurm_schedulers:
                if _item_slurm_schedulers:
                    _items.append(_item_slurm_schedulers.to_dict())
            _dict['slurm_schedulers'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkflowSpecificationsSchedulers from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aws_schedulers": [AwsSchedulerModel.from_dict(_item) for _item in obj["aws_schedulers"]] if obj.get("aws_schedulers") is not None else None,
            "local_schedulers": [LocalSchedulerModel.from_dict(_item) for _item in obj["local_schedulers"]] if obj.get("local_schedulers") is not None else None,
            "slurm_schedulers": [SlurmSchedulerModel.from_dict(_item) for _item in obj["slurm_schedulers"]] if obj.get("slurm_schedulers") is not None else None
        })
        return _obj
